/*
 			CCT.C 						(c) 1993 Till Harbaum
 			
 			implementiert die Kommandos fr den Videotext-Decoder
*/

#include <stdlib.h>
#include <stdio.h>
#include <ext.h>
#include "videotxt.h"

#define DOCARE  16
#define NOTHOLD  8
#define correct_hamming(a)    (ham_tab[a])

#define HEX2DEC(a) (((a)<='9')?((a)-'0'):( ((a)<='Z')?((a)-'A'+10):((a)-'a'+10) ))
#define HEADLINE 17

/* Statusbyte aus CCT lesen */
int	i2cstat(void)
{
	unsigned char	i2c_buff[2] ;
	int		stat ;
	unsigned char	i2creturn ;
	
	/* R11B selektieren*/
	i2c_buff[0] = 0 ;
	i2c_buff[1] = 1 ;
	sendi2c (CCTWrite, 2, i2c_buff);

	/* TCS ON */
	i2c_buff[0] = 1 ;
	i2c_buff[1] = 4 ;
	sendi2c (CCTWrite, 2, i2c_buff);

	/* R11B addressieren zum Lesen */
	i2c_buff[0] = 11 ;
	sendi2c (CCTWrite, 1, i2c_buff);

	/* Status lesen */
  receivei2c (CCTRead, 1, &i2creturn);
	stat = i2creturn ;
	
	/* R11 selektieren*/
	i2c_buff[0] = 0 ;
	i2c_buff[1] = 0 ;
	sendi2c (CCTWrite, 2, i2c_buff);
	
	return stat;
} 

/* CCT einschalten */
void acqon (void)
{
	unsigned char	i2c_buff[2] ;

	/* ACQ on */
	i2c_buff[0] = 1 ;
	i2c_buff[1] = 4 ;
	sendi2c (CCTWrite, 2, i2c_buff);
}
 
/* CCT abschalten */
void acqoff (void)
{
	unsigned char	i2c_buff[2] ;

	/* ACQ off */
	i2c_buff[0] = 1 ;
	i2c_buff[1] = 36 ;
	sendi2c (CCTWrite, 2, i2c_buff);
}

/* Seite im CCT lschen */
void clear(int speicher)
{
	unsigned char	i2c_buff[2] ;

	i2c_buff[0] = 8 ;
	i2c_buff[1] = speicher + 8 ;
	sendi2c (CCTWrite, 2, i2c_buff);
}

/* holt eine empfangene Seite aus dem Speicher des CCT */
void getpage(int seitenr, unsigned char *speicher)
{
	unsigned char	i2c_buff[4] ;
	int   i;
	
/*	acqoff() ; */
	
	/*Seite aus CCT lesen*/
 	i2c_buff[0] = 8 ;
 	i2c_buff[1] = seitenr ;
 	i2c_buff[2]	= i2c_buff[3] = 0 ;
 	sendi2c(CCTWrite, 4, i2c_buff);
	receivei2c (CCTRead, 960, speicher);

	/* erste 8 Statusbytes lschen */
	for(i=0;i<8;i++)
		speicher[i]=' ';

	/* Statusbytes aus CCT lesen */
 	i2c_buff[0] = 8 ;
	i2c_buff[1] = seitenr ;
 	i2c_buff[2]	= 25 ;
 	i2c_buff[3] = 0 ;
 	sendi2c(CCTWrite, 4, i2c_buff);
	receivei2c (CCTRead, 10, speicher+960);
}

/* nachgucken, ob Seite schon da */
int arrived(int seitenr)
{
	unsigned char	i2c_buff[4] ;

 	i2c_buff[0] = 8 ;
 	i2c_buff[1] = seitenr ;
 	i2c_buff[2]	= 25 ;
 	i2c_buff[3] =  9 ;
 	sendi2c(CCTWrite, 4, i2c_buff);
	receivei2c (CCTRead, 1, i2c_buff);

	return((i2c_buff[0] & 0x20)==0);
}

void  readpage(int pagenr, int pagebuff)
{
	unsigned char	i2c_buff[10] ;
	
	i2c_buff[0] = 2 ;
	i2c_buff[1] = pagebuff * 16 ;
	i2c_buff[2] = ((pagenr >> 8 ) % 8 ) + DOCARE + NOTHOLD ;
	i2c_buff[3] = ((pagenr >> 4 ) & 0x0f ) + DOCARE ;
	i2c_buff[4] = (pagenr & 0x0f ) + DOCARE ;
	i2c_buff[5] = i2c_buff[6] = i2c_buff[7] = i2c_buff[8] = 0;
	sendi2c(CCTWrite, 9, i2c_buff) ;

	i2c_buff[0] = 8 ;
	i2c_buff[1] = pagebuff ;  
	i2c_buff[2] = 0 ;  
	i2c_buff[3] = 3 ;  
	i2c_buff[4] = 77 ;
	i2c_buff[5] = pagebuff + 48 ;
	sendi2c(CCTWrite, 6, i2c_buff) ;	
}

void  inittele(void) 
{
	unsigned char	i2c_buff[16] ;
	int		i ;
	
	reseti2c() ;

	/* R11 lesen und nicht R11b */
	i2c_buff[0] = i2c_buff[1] = 0 ;
	sendi2c (CCTWrite, 2, i2c_buff) ;
	
	/* CCT aktivieren */
	i2c_buff[0] = 1 ;  
	i2c_buff[1] = 4 ;
	sendi2c(CCTWrite, 2, i2c_buff) ;
	
	for (i=0; i<8; i++)
	{
		delay (100) ;
		clear (i) ;
	}
}

/* -------------------- TOP-TEXT-Routinen ------------------------ */
/* abtesten, ob TOP-Text vorhanden */
extern char hex[];
extern int top_da,adips_da;
void check_adips(int wx, int wy,int page);
int adip_nr[3],ad=-1;
static search_top=FALSE;
static unsigned char top_page[1024];
#define TOP_ACQ  1				/* TOP text acquisition unit */
#define ADIP_ACQ 2				/* ADIP acquisition unit */
#define TOP_BASE 0x1F0
int check_top(int wx, int wy, int page)
{
	int da,i,adip;

	if(top_da)
		check_adips(wx,wy,page);

	if(!search_top)
	{
		search_top=TRUE;
		readpage(TOP_BASE,TOP_ACQ);
	}
	
	if((da=arrived(TOP_ACQ))==TRUE)
	{
		delay(100);
		getpage(TOP_ACQ,top_page);
		for(i=40;i<960;i++)
		  top_page[i]=hex[correct_hamming((unsigned)top_page[i])];

		adip_nr[0]=adip_nr[1]=adip_nr[2]=0;

		for(adip=0,i=0;i<10;i++)
		{
			if(top_page[847+8*i]=='2')	/* eine ADIP-Kennung ?? */
			{
				if(adip<3)	/* max. 3 ADIPS */
				{
					adip_nr[adip]=256*HEX2DEC(top_page[840+8*i])+
											   16*HEX2DEC(top_page[841+8*i])+
											      HEX2DEC(top_page[842+8*i]);

					adip++;
				}
			}
		}

		/* Nur wenn schon alle ADIPS drin von vorne starten */
		if(ad==-1)
		{
			/* ADIPS in 2ter Acquisition-Unit anfordern */
			readpage(adip_nr[0],ADIP_ACQ);
			ad=0;
		}

		readpage(TOP_BASE,TOP_ACQ);
	}

	return(da);
}

/* testen, ob Seite lt. TOP-Text vorhanden */
int check_page_top(int nr)
{
	int page_offset;

	/* bei keinem TOP-Text immer Seite da! */
	if(!top_da)
		return(TRUE);
	else
	{
		/* Hex-Seiten sind nicht vertreten -> also immer ok */
		if( ((nr&0x0f)>9) || (((nr>>4)&0x0f)>9) || (((nr>>8)&0x0f)>9) )
			return(TRUE);
	
		/* HEX->DEZ wandeln */
		page_offset=(nr&0x0f)+10*((nr>>4)&0x0f)+100*((nr>>8)&0x0f)-100;
	
		/* Null heit keine Seite da */
		if(top_page[40+page_offset]=='0')
			return(FALSE);
		else
			return(TRUE);
	}
}

/* Anzahl benutzter Seiten zhlen */
int get_page_anz(void)
{
	int i,num=0;

	for(i=40;i<840;i++)
	{
		if(top_page[i]!='0')
			num++;
	}
	return(num);
}


unsigned char adip[1024];	/* Puffer fr ADIP-Seite */
char adip_text[133][12];
int	 adip_page[133];
int  a[3];

int  get_adip_pagenum(int pos)
{
#if 0
	printf("\033H %X %X %X  ",adip_page[a[0]],adip_page[a[1]],adip_page[a[2]]);
#endif

	return(adip_page[a[pos]]);
}

/* TOP-Zeile fr aktuelle Seite basteln */
void top_zeile(int wx, int wy, int page)
{
	int i,y,f1=0x100,f2=0x899;

	y=wy+288+HEADLINE+2;

	if(!adips_da)
	{
		set_back(0);
		for(i=0;i<40;i++)
			draw_chr(wx+i*12,y,' ',0,FALSE);

		return;
	}
	
	a[0]=0; a[1]=1; a[2]=2;
	
	for(i=0;adip_page[i]!=-1;i++)
	{
		if((adip_page[i]>0x100)&&(adip_page[i]<0x899))
		{
			if((adip_page[i]>f1)&&(adip_page[i]<page))
			{
				f1=adip_page[i];				
				a[1]=i;
			}
		}
	}
				
	for(i=0;adip_page[i]!=-1;i++)
	{
		if((adip_page[i]>0x100)&&(adip_page[i]<0x899))
		{
			if((adip_page[i]<f2)&&(adip_page[i]>page)&&(adip_page[i]>adip_page[a[1]]))
			{
				f2=adip_page[i];
				a[2]=i;
			}
		}
	}
	
#if 0
	printf("\033H (%X) 0:%X <:%X >:%X ",page,adip_page[a[0]],adip_page[a[1]],adip_page[a[2]]);
#endif
	
	set_back(1);
	draw_chr(wx,y,' ',0,FALSE);
	for(i=0;i<12;i++)
		draw_chr(wx+12+i*12,y,adip_text[a[0]][i],0,FALSE);
	set_back(2);
	draw_chr(wx+156,y,' ',0,FALSE);
	for(i=0;i<12;i++)
		draw_chr(wx+168+i*12,y,adip_text[a[1]][i],0,FALSE);
	set_back(3);
	draw_chr(wx+312,y,' ',0,FALSE);
	for(i=0;i<12;i++)
		draw_chr(wx+324+i*12,y,adip_text[a[2]][i],0,FALSE);
	draw_chr(wx+468,y,' ',0,FALSE);
}

void check_adips(int wx, int wy, int page)
{
	int i,j;

	if(arrived(ADIP_ACQ))	/* ADIP lesen */
	{
		delay(150);
		getpage(ADIP_ACQ,adip);
		for(i=0;i<44;i++)
			for(j=0;j<8;j++)
		  	adip[40+(20*i)+j]=hex[correct_hamming((unsigned)adip[40+(20*i)+j])];
		
		for(i=0;i<44;i++)
		{
			for(j=0;j<12;j++)
				adip_text[44*ad+i][j]=adip[48+(20*i)+j];
				
			adip_page[44*ad+i]= (adip[40+(20*i)]-'0')*256+
													(adip[41+(20*i)]-'0')*16+
													(adip[42+(20*i)]-'0');
		}

		adip_page[44*(ad+1)]=-1;
		
		ad++;		
		if((ad<3)&&(adip_nr[ad]!=0))					/* ggf. nchste ADIP holen */
		{
			readpage(adip_nr[ad],ADIP_ACQ);
		}
		else
		{
			/* alle ADIPS da! */
			adips_da=TRUE;
			mouse_off();
			top_zeile(wx,wy,page);
			mouse_on();
			ad=-1;
		}
	}
}