/*
		Videotext-Decoder Grafik-Routinen
*/

#include <vdi.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <ext.h>
#include <tos.h>
#include <aes.h>
#include "videotxt.h"
#include "videochr.h"
#include "videogfx.h"
#include "videolng.h"

extern int handle;
extern int x_col;
extern int prt_adap;

void get_page(int page);

int grafik[64][16];
int grafik2[64][16];
int big_zeichen[96][32];
int big_grafik[64][32];
int big_grafik2[64][32];
int big_sprache[65][32];

unsigned 	char	stats;
unsigned	char	i2cd[10];
unsigned	char	seite[1024];
int	 x,y;
int *buffer;

int  test_signal( void )
{
	static int  old_stat=-1;
	int		stats,ret;
	
	stats=i2cstat()&3;
	if(stats>2)
		stats--;

	if(stats!=old_stat)
		ret=5-stats;
	else
		ret=0;

	old_stat=stats;
	return(ret);
}

void init_videotext(void)
{
	int i,b,d;

	for(i=0;i<96;i++)
		for(b=0;b<16;b++)
			big_zeichen[i][2*b+1]=big_zeichen[i][2*b]=zeichen[i][b];

	for(i=0;i<65;i++)
		for(b=0;b<16;b++)
			big_sprache[i][2*b+1]=big_sprache[i][2*b]=sprache[i][b];
	
	for(i=0;i<64;i++)
	{
		for(b=0;b<16;b++)
		{
			grafik[i][b]=0;
			grafik2[i][b]=0;
		}
		
		for(b=0;b<6;b++)
		{
			if(i&(1<<b))
			{
				for(d=0;d<16;d++)
				{
					grafik[i][d]|=graphix[b][d];
					grafik2[i][d]|=graphix[b+6][d];
				}
			}
		}
		for(b=0;b<16;b++)
		{
			big_grafik[i][2*b+1]=big_grafik[i][2*b]=grafik[i][b];
			big_grafik2[i][2*b+1]=big_grafik2[i][2*b]=grafik2[i][b];
		}
		
	}

	stats =  i2cstat() ;

	i2cd[0] = 0 ;
	i2cd[1] = 0 ;
	sendi2c(CCTWrite, 2, i2cd);
	inittele() ;
}

int blinkend=FALSE,back;
int blink_list_hint[8],blink_list_vor[8],blink_anz=0;
int color_array[][2]={{1,1},{2,1},{11,1},{6,1},{4,1},{7,1},{5,1},{0,1}};
int color_blink[]={1,1};
int color_trans[]={1,2,11,6,4,7,5,0};
void draw_chr(int x, int y, int chr, int color, int big)
{
	MFDB src,dest;
	int  pxy[10],i,found,colarr[3];
	
	if(big)
	{
		src.fd_addr=big_zeichen[chr-32];
		src.fd_h=24;
		pxy[0]=0; pxy[1]=0; pxy[2]=11; pxy[3]=23;
		pxy[4]=x; pxy[5]=y; pxy[6]=x+11; pxy[7]=y+23;
	}
	else
	{
		src.fd_addr=zeichen[chr-32];
		src.fd_h=12;
		pxy[0]=0; pxy[1]=0; pxy[2]=11; pxy[3]=11;
		pxy[4]=x; pxy[5]=y; pxy[6]=x+11; pxy[7]=y+11;
	}
	
	src.fd_w=12;
	src.fd_wdwidth=1;
	src.fd_stand=1;
	src.fd_nplanes=1;
	
	dest.fd_addr=NULL;
	
	if((!blinkend)||(x_col<24))
		vrt_cpyfm(handle,MD_REPLACE,pxy,&src,&dest,color_array[color]);
	else
	{
		i=0;
		found=FALSE;

		while((i<blink_anz)&&(i<8)&&(!found))
		{
			if((blink_list_hint[i]==color_trans[back])&&
				(blink_list_vor[i]==color_trans[color]))
				found=TRUE;
			else
				i++;
		}
		
		if(i==8)
			vrt_cpyfm(handle,MD_REPLACE,pxy,&src,&dest,color_array[color]);
		else
		{
			if(!found)
			{
				blink_list_hint[i]=color_trans[back];
				blink_list_vor[i]=color_trans[color];
				blink_anz++;
			}
			
			color_blink[0]=i+16;
			vq_color(handle,blink_list_vor[i],1,colarr);
			vs_color(handle,i+16,colarr);
			vrt_cpyfm(handle,MD_REPLACE,pxy,&src,&dest,color_blink);
		}
	}
}


int ges_col;
void print_chr(int x, int y, int chr, int color, int big)
{
	int  i;
	unsigned int *quelle,*ziel,src;
	
	if(big)
		quelle=(unsigned int*)big_zeichen[chr-32];
	else
		quelle=(unsigned int*)zeichen[chr-32];

	ziel=(unsigned int*)buffer+x*3/4+y*12*30;

	for(i=0;i<12+big*12;i++)
	{
		src=*quelle&0xfff0;
	
		switch(x%4)
		{
			case 0:		*ziel=*ziel|src;
								break;
			case 1:		*ziel=*ziel|(src>>12);
								*(ziel+1)=*(ziel+1)|(src<<4);
								break;
			case 2:		*ziel=*ziel|(src>>8);
								*(ziel+1)=*(ziel+1)|(src<<8);
								break;
			case 3:		*ziel=*ziel|(src>>4);
								break;
		}
		ziel+=30;
		quelle++;
	}
	ges_col=color;
}

void draw_gfx(int x, int y, int chr, int color, int conti, int big)
{
	MFDB src,dest;
	int  pxy[10],i,found,colarr[3];
		
	if(conti)
	{
		if(chr<64)
		{
			if(!big)
				src.fd_addr=grafik[chr-32];
			else
				src.fd_addr=big_grafik[chr-32];
		}
		else
		{
			if(!big)
				src.fd_addr=grafik[chr-64];
			else
				src.fd_addr=big_grafik[chr-64];
		}
	}
	else
	{
		if(chr<64)
		{
			if(!big)
				src.fd_addr=grafik2[chr-32];
			else
				src.fd_addr=big_grafik2[chr-32];
		}
		else
		{
			if(!big)
				src.fd_addr=grafik2[chr-64];
			else
				src.fd_addr=big_grafik2[chr-64];
		}
	}

	src.fd_w=12;
	if(!big)
	{
		pxy[0]=0; pxy[1]=0; pxy[2]=11; pxy[3]=11;
		pxy[4]=x; pxy[5]=y; pxy[6]=x+11; pxy[7]=y+11;
	
		src.fd_h=12;
	}
	else
	{
		pxy[0]=0; pxy[1]=0; pxy[2]=11; pxy[3]=23;
		pxy[4]=x; pxy[5]=y; pxy[6]=x+11; pxy[7]=y+23;
	
		src.fd_h=24;
	}
	src.fd_wdwidth=1;
	src.fd_stand=1;
	src.fd_nplanes=1;
	
	dest.fd_addr=NULL;
	
	if((!blinkend)||(x_col<24))
		vrt_cpyfm(handle,MD_REPLACE,pxy,&src,&dest,color_array[color]);
	else
	{
		i=0;
		found=FALSE;

		while((i<blink_anz)&&(i<8)&&(!found))
		{
			if((blink_list_hint[i]==color_trans[back])&&
				(blink_list_vor[i]==color_trans[color]))
				found=TRUE;
			else
				i++;
		}
		
		if(i==8)
			vrt_cpyfm(handle,MD_REPLACE,pxy,&src,&dest,color_array[color]);
		else
		{
			if(!found)
			{
				blink_list_hint[i]=color_trans[back];
				blink_list_vor[i]=color_trans[color];
				blink_anz++;
			}
			
			color_blink[0]=i+16;
			vq_color(handle,blink_list_vor[i],1,colarr);
			vs_color(handle,i+16,colarr);
			vrt_cpyfm(handle,MD_REPLACE,pxy,&src,&dest,color_blink);
		}
	}
}

void print_gfx(int x, int y, int chr, int color, int conti, int big)
{
	int  	i;
	unsigned int	*quelle,*ziel,src;
		
	if(conti)
	{
		if(chr<64)
		{
			if(!big)
				quelle=(unsigned int*)grafik[chr-32];
			else
				quelle=(unsigned int*)big_grafik[chr-32];
		}
		else
		{
			if(!big)
				quelle=(unsigned int*)grafik[chr-64];
			else
			  quelle=(unsigned int*)big_grafik[chr-64];
		}
	}
	else
	{
		if(chr<64)
		{
			if(!big)
				quelle=(unsigned int*)grafik2[chr-32];
			else
				quelle=(unsigned int*)big_grafik2[chr-32];
		}
		else
		{
			if(!big)
				quelle=(unsigned int*)grafik2[chr-64];
			else
				quelle=(unsigned int*)big_grafik2[chr-64];
		}
	}
	ziel=(unsigned int*)buffer+x*3/4+y*12*30;

	for(i=0;i<12+big*12;i++)
	{
		src=*quelle&0xfff0;
	
		switch(x%4)
		{
			case 0:		*ziel=*ziel|src;
								break;
			case 1:		*ziel=*ziel|(src>>12);
								*(ziel+1)=*(ziel+1)|(src<<4);
								break;
			case 2:		*ziel=*ziel|(src>>8);
								*(ziel+1)=*(ziel+1)|(src<<8);
								break;
			case 3:		*ziel=*ziel|(src>>4);
								break;
		}
		ziel+=30;
		quelle++;
	}
	ges_col=color;
}

void  set_back(int color)
{
	int i;
	
	if(x_col<16)
		color=1;
	
	for(i=0;i<8;i++)
		color_array[i][1]=color_trans[color];
	
	color_blink[1]=color_trans[color];
}

void set_print_back(int color)
{
	ges_col=color;
}

int ex_list[]={3,4,32,59,60,61,62,63,64,91,92,93,94};
void set_language(int language)
{
	/* jetzt die Zeichen der entsprechenden Sprache reinkopieren */
	int i,b;
	static akt_langue=-1;

	if(language!=akt_langue)
	{
		for(i=0;i<13;i++)		/* fnfzehn Sonderzeichen */
		{
			for(b=0;b<16;b++)		/* normales Zeichen */
				zeichen[ex_list[i]][b]=sprache[i+language*13][b];
				
			for(b=0;b<32;b++)		/* groe Zeichen */
				big_zeichen[ex_list[i]][b]=big_sprache[i+language*13][b];
		}
		
		akt_langue=language;
	}
}

extern int searching;
void get_page(int page)
{
	searching=TRUE;
	
	clear (0) ;
/*	acqon() ; */
	readpage (page, 0 );
}

int big_flag[40];
int big_back[40];
int hidden=TRUE;
int lang_list[]={0,4,2,0,1,0,3,0};
extern int help;
extern unsigned char hilfe_seite[];
void draw_videotext(int wx, int wy)
{
	int x,y,zeichen,grafik_an,color,over,last_chr,last_col,last_back;
	int last_graf,last_was_chr,conti,last_conti,big,last_big;
	int last_was_big=FALSE,x_big=FALSE,raetsel,start=3;

	blink_anz=0;
	for(y=0;y<40;y++)	big_flag[y]=FALSE;

	if(!help)
		set_language(lang_list[(seite[967]&0xe)/2]);
	else
		set_language(0);		/* Hilfe ist auf Englisch (wg. @) */

	for(y=0;y<=23;y++)
	{
		color=7;
		grafik_an=FALSE;
		over=FALSE;
		back=0;
		conti=TRUE;
		big=FALSE;
		last_was_big=x_big;
		x_big=FALSE;
		raetsel=FALSE;
		blinkend=FALSE;
	
		for(x=start;x<40;x++)
		{
			if(!help)
				zeichen=seite[x+y*40];
			else
				zeichen=hilfe_seite[x+y*40];
			
			if(big)
				x_big=TRUE;

			if((zeichen>=32)&&(zeichen<128))
			{
				if(raetsel&&hidden)
					zeichen=32;
			
				if(last_was_big)
					set_back(big_back[x]);
				else
					set_back(back);

				big_back[x]=back;
			
				if(!big_flag[x])		/* in letzter Zeile hier kein groes Zeichen */
				{					
					if(grafik_an)
					{
						if((zeichen>=64)&&(zeichen<96))
							draw_chr(wx+12*x,wy+12*y,zeichen,color,big);
						else
							draw_gfx(wx+12*x,wy+12*y,zeichen,color,conti,big);

						last_was_chr=TRUE;
					}
					else
						draw_chr(wx+12*x,wy+12*y,zeichen,color,big);

					big_flag[x]=big;
				}
				else
					big_flag[x]=FALSE;

				last_chr=zeichen;
				last_graf=grafik_an;
				last_col=color;
				last_back=back;
				last_conti=conti;
				last_big=big;
			}
			else
			{
				switch(zeichen)
				{
					case 0:
					case 1:
					case 2:
					case 3:
					case 4:
					case 5:
					case 6:
					case 7:		color=zeichen;
										grafik_an=FALSE;
										raetsel=FALSE;
										break;
					case 8:		blinkend=TRUE;
										break;
					case 9:		blinkend=FALSE;
										break;										
					case 12:  big=FALSE;
										break;
					case 13:  big=TRUE;
										break;
					case 16:
					case 17:
					case 18:
					case 19:
					case 20:
					case 21:
					case 22:
					case 23: 	color=zeichen-16;
										grafik_an=TRUE;
										raetsel=FALSE;
										break;
				 	case 24:	raetsel=TRUE;
				 						break;
					case 25:  conti=TRUE;
										break;
					case 26:	conti=FALSE;
										break;
					case 28:	back=0;
										break;
					case 29:	back=color;
										break;
					case 30:  over=TRUE;
										break;
					case 31:  over=FALSE;
										break;
				}
				if(x_col<16)
					color=7;

				if(over&&last_was_chr)
				{
					set_back(last_back);
					big_back[x]=last_back;
					
					if(!big_flag[x])		/* in letzter Zeile hier kein groes Zeichen */
					{
						if(last_graf)
						{
							if((zeichen>=64)&&(zeichen<96))
								draw_chr(wx+12*x,wy+12*y,' ',last_col,last_big);
							else
								draw_gfx(wx+12*x,wy+12*y,last_chr,last_col,last_conti,last_big);
						}
						else
							draw_chr(wx+12*x,wy+12*y,' ',last_col,last_big);

						big_flag[x]=last_big;
					}
					else
						big_flag[x]=FALSE;
					
					last_was_chr=FALSE;
				}
				else
				{
					if(last_was_big)
						set_back(big_back[x]);
					else
						set_back(back);

					big_back[x]=back;

					if(!big_flag[x])
					{
						draw_chr(wx+12*x,wy+12*y,' ',color,big);
						big_flag[x]=big;
					}
					else
						big_flag[x]=FALSE;
				}
			}
		}
		start=0;
	}
	blinkend=FALSE;
}

void print_page()
{
	int x,y,zeichen,grafik_an,color,over,last_chr,last_col,last_back;
	int last_graf,last_was_chr,conti,last_conti,big,last_big;
	int last_was_big=FALSE,x_big=FALSE,raetsel,i;

 buffer=malloc(20000l);

 if(buffer!=NULL)
 {
  for(i=0;i<10000;i++)
  	buffer[i]=0;

	blink_anz=0;
	for(y=0;y<40;y++)	big_flag[y]=FALSE;

	if(!help)
		set_language(lang_list[(seite[967]&0xe)/2]);
	else
		set_language(1);		/* Hilfe ist auf deutsch */

	for(y=0;y<=23;y++)
	{
		color=7;
		grafik_an=FALSE;
		over=FALSE;
		back=0;
		conti=TRUE;
		big=FALSE;
		last_was_big=x_big;
		x_big=FALSE;
		raetsel=FALSE;
		blinkend=FALSE;
	
		for(x=0;x<40;x++)
		{
			if(!help)
				zeichen=seite[x+y*40];
			else
				zeichen=hilfe_seite[x+y*40];
			
			if(big)
				x_big=TRUE;

			if((zeichen>=32)&&(zeichen<128))
			{
				if(raetsel&&hidden)
					zeichen=32;
			
				if(last_was_big)
					set_print_back(big_back[x]);
				else
					set_print_back(back);

				big_back[x]=back;
			
				if(!big_flag[x])		/* in letzter Zeile hier kein groes Zeichen */
				{					
					if(grafik_an)
					{
						if((zeichen>=64)&&(zeichen<96))
							print_chr(x,y,zeichen,color,big);
						else
							print_gfx(x,y,zeichen,color,conti,big);

						last_was_chr=TRUE;
					}
					else
						print_chr(x,y,zeichen,color,big);

					big_flag[x]=big;
				}
				else
					big_flag[x]=FALSE;

				last_chr=zeichen;
				last_graf=grafik_an;
				last_col=color;
				last_back=back;
				last_conti=conti;
				last_big=big;
			}
			else
			{
				switch(zeichen)
				{
					case 0:
					case 1:
					case 2:
					case 3:
					case 4:
					case 5:
					case 6:
					case 7:		color=zeichen;
										grafik_an=FALSE;
										raetsel=FALSE;
										break;
					case 8:		blinkend=TRUE;
										break;
					case 9:		blinkend=FALSE;
										break;										
					case 12:  big=FALSE;
										break;
					case 13:  big=TRUE;
										break;
					case 16:
					case 17:
					case 18:
					case 19:
					case 20:
					case 21:
					case 22:
					case 23: 	color=zeichen-16;
										grafik_an=TRUE;
										raetsel=FALSE;
										break;
				 	case 24:	raetsel=TRUE;
				 						break;
					case 25:  conti=TRUE;
										break;
					case 26:	conti=FALSE;
										break;
					case 28:	back=0;
										break;
					case 29:	back=color;
										break;
					case 30:  over=TRUE;
										break;
					case 31:  over=FALSE;
										break;
				}
				if(x_col<16)
					color=7;

				if(over&&last_was_chr)
				{
					set_print_back(last_back);
					big_back[x]=last_back;
					
					if(!big_flag[x])		/* in letzter Zeile hier kein groes Zeichen */
					{
						if(last_graf)
						{
							if((zeichen>=64)&&(zeichen<96))
								print_chr(x,y,' ',last_col,last_big);
							else
								print_gfx(x,y,last_chr,last_col,last_conti,last_big);
						}
						else
							print_chr(x,y,' ',last_col,last_big);

						big_flag[x]=last_big;
					}
					else
						big_flag[x]=FALSE;
					
					last_was_chr=FALSE;
				}
				else
				{
					if(last_was_big)
						set_print_back(big_back[x]);
					else
						set_print_back(back);

					big_back[x]=back;

					if(!big_flag[x])
					{
						print_chr(x,y,' ',color,big);
						big_flag[x]=big;
					}
					else
						big_flag[x]=FALSE;
				}
			}
		}
	}
	blinkend=FALSE;

	if(!prt_adap)
		form_alert(1,"[1][ Bitte den Drucker | an den Centronix-Port | anschlieen ! ][ Erledigt ]");

	/* und nun drucken */
	if(Bcostat(0)==-1l)
	{
		int spalte,zeile,byte,bit;

		Bconout(0,13);
	
		/* Vorschub: 8/72" */
		Bconout(0,27); Bconout(0,65); Bconout(0,8);
	
		for(zeile=0;zeile<36;zeile++)
		{
			Bconout(0,27); Bconout(0,75); Bconout(0,224); Bconout(0,1);

			for(spalte=0;spalte<480;spalte++)
			{
				byte=0;
			
				for(bit=0;bit<8;bit++)
				{
					if(buffer[zeile*30*8+spalte/16+bit*30]&(1<<(15-(spalte%16))))
						byte|=1<<(7-bit);
				}
			
				Bconout(0,byte);
			}
			Bconout(0,13);
			Bconout(0,10);
		}
		
		/* Vorschub 12/72" (1/6") */
		Bconout(0,27); Bconout(0,65); Bconout(0,12);
	}
	else
		form_alert(1,"[1][ Drucker nicht bereit! ][ Och! ]");

	if(!prt_adap)
		form_alert(1,"[1][ Druckvorgang beendet. Jetzt | bitte den Videotextdekoder an | den Centronix-Port anschlieen ! ][ Erledigt ]");

	free(buffer);
 }
 else
 	form_alert(1,"[1][ Kann 20kByte Druck- | puffer nicht allozieren!][ Oh ]");
}
